;;; test-init.el --- Outline-based notes management and organizer
;; Copyright (C) 2004-2011 Free Software Foundation, Inc.
;; Author: Martyn Jago
;; Requires the non-emacs files ert-batch.el and ert-run.el (in /path/to/org/testing)
;; Working directory is assumed to be /path/to/org/testing
;; ...and a batch script something like...
;;   /path/to/emacs/executable/Emacs -batch -l /path/to/testing/test-init.el

;; directory locations...
(let ((org-dir "~/org-mode/")
      (emacs-lisp-dir "/Applications/Emacs.app/Contents/Resources/lisp/emacs-lisp/"))

  ;; load-path...
  (add-to-list 'load-path "/Applications/Emacs.app/Contents/Resources/lisp/emacs-lisp/")
  (mapcar (lambda (lp) "iterate over files to load"
            (add-to-list 'load-path lp))
          (list
           emacs-lisp-dir                      (concat org-dir "lisp")
           (concat org-dir "testing")          (concat org-dir "testing/lisp")
           (concat org-dir "testing/examples") (concat org-dir "testing/contrib")
           (concat org-dir "contrib")          (concat org-dir "contrib/lisp")
           (concat org-dir "contrib/babel/langs")))

  ;; babel languages...       
  (setq org-confirm-babel-evaluate nil)
  (org-babel-lob-ingest (concat org-dir "contrib/babel/library-of-babel.org"))
  (org-babel-do-load-languages
   'org-babel-load-languages
   '((ruby . t) (python . t) (C . t) (emacs-lisp . t)
     (sh t) (dot t) (clojure t) (ditaa t) (lilypond t)))

  ;; test files...
  (mapcar (lambda (test-file) "iterate over all test files in testing/lisp"
            (load-file test-file))
          (directory-files (concat org-dir "testing/lisp") 1 ".*\.el" 1))

  ;; run tests
  (message "\n------------------------- Test start --------------------------------------\n")
  (message (version))
  (org-version)
  (message "\n")
  (ert-run-tests-batch-and-exit))

